package main

import (
	"context"
	"os"
	"os/signal"
	"syscall"

	"git.frostfs.info/TrueCloudLab/frostfs-s3-gw/cmd/s3-authmate/modules"
)

func main() {
	ctx, _ := signal.NotifyContext(context.Background(), syscall.SIGINT, syscall.SIGTERM, syscall.SIGHUP)

	if cmd, err := modules.Execute(ctx); err != nil {
		cmd.PrintErrln("Error:", err.Error())
		cmd.PrintErrf("Run '%v --help' for usage.\n", cmd.CommandPath())
		os.Exit(modules.ExitCode(err))
	}
}
